// DP5CfgWnd.cpp : implementation file
//

#include "stdafx.h"
//#include "CDP5Cfg.h"
#include "DP5CfgWnd.h"
#include "FilePage.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDP5CfgWnd

IMPLEMENT_DYNAMIC(CDP5CfgWnd, CCfgPropSheet)

CDP5CfgWnd::CDP5CfgWnd(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CCfgPropSheet(nIDCaption, pParentWnd, iSelectPage)
{
	m_bModal = FALSE;

	AddPages();
}

CDP5CfgWnd::CDP5CfgWnd(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CCfgPropSheet(pszCaption, pParentWnd, iSelectPage)
{
	m_bModal = FALSE;

	AddPages();
}

CDP5CfgWnd::~CDP5CfgWnd()
{

}

void CDP5CfgWnd::AddPages(void)
{
	AddPage(&m_FilePage);
	AddPage(&m_McaPage);
	AddPage(&m_ShapingPage);
	AddPage(&m_GainPzPage);
	AddPage(&m_PowerPage);
	AddPage(&m_MiscPage);
	//AddPage(&m_BootOptPage);
}

BEGIN_MESSAGE_MAP(CDP5CfgWnd, CCfgPropSheet)
	//{{AFX_MSG_MAP(CDP5CfgWnd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDP5CfgWnd message handlers

BOOL CDP5CfgWnd::OnInitDialog() 
{

	BOOL bResult = CCfgPropSheet::OnInitDialog();
	
	InitCfgPropSheet(TRUE,TRUE,NULL,0,IDR_MENU,IDR_TOOLBAR);
	
	CString CsBtnText;
	if (m_bModal) {
		CsBtnText.LoadString(IDS_BTNSTRING_MODELESS);
	} else {
		CsBtnText.LoadString(IDS_BTNSTRING_MODAL);
	}
	return bResult;
}

INT_PTR CDP5CfgWnd::DoModal() 
{
	m_bModal = TRUE;	
	return CCfgPropSheet::DoModal();
}
