#if !defined(AFX_DP5CfgWnd_H__INCLUDED_)
#define AFX_DP5CfgWnd_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DP5CfgWnd.h : header file
//

#include "CfgPropSheet.h"
#include "FilePage.h"
#include "McaPage.h"
#include "ShapingPage.h"
#include "GainPzPage.h"
#include "PowerPage.h"
#include "MiscPage.h"
//#include "BootOptPage.h"

/////////////////////////////////////////////////////////////////////////////
// CDP5CfgWnd

class CDP5CfgWnd : public CCfgPropSheet
{
	DECLARE_DYNAMIC(CDP5CfgWnd)

// Construction
public:
	CDP5CfgWnd(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CDP5CfgWnd(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

// Attributes
public:
	CFilePage m_FilePage;
	CMcaPage m_McaPage;
	CShapingPage m_ShapingPage;
	CGainPzPage m_GainPzPage;
	CPowerPage m_PowerPage;
	CMiscPage m_MiscPage;
	//CBootOptPage m_BootOptPage;

	BOOL m_bModal;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDP5CfgWnd)
	public:
	virtual BOOL OnInitDialog();
	virtual INT_PTR DoModal();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDP5CfgWnd();

	// Generated message map functions
protected:
	
	void AddPages(void);
	//{{AFX_MSG(CDP5CfgWnd)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DP5CfgWnd_H__INCLUDED_)
