#pragma once

#include ".\sca.h"


class CScaFn
{
public:
	CScaFn(void);
	~CScaFn(void);

	CString SCA_SECTION;
	CString CFG_SECTION;

	BOOL SplitData(CString strData, CString *varValue, CString strDefault);

	long varValueToIndex(CString varData);

	void SaveSCASetupINI(CSca sca);
	void DeleteIniSettingEx(CString strFilename, CString strSection, CString strKey);
	void SaveToIniEx(CString strFilename, CString strSection, CString strKey, CString strData);
	void SaveSCASettingsINI(CSca sca, long Index);
	void GetSCASetupINI(CSca *sca);
	CString GetFromIniEx(CString strFilename, CString strSection, CString strKey, CString strDefault);
	void GetSCASettingsINI(CSca *sca, long Index);
	void ReadSCASetting(CSca *sca, CString strSCAInfo);
	CString GetNextCMD(CString strCMDList);
	void SCACfgParser(CSca *sca, CString strSCASettings);
	CString SCAString(CString strCmd, CString strData, BOOL bDppMsg = TRUE);
	CString SCASetupString(CSca sca, BOOL bDppMsg = TRUE);
	CString SCASettingsString(CSca sca, long Index, BOOL bDppMsg = TRUE);
	CString SCAStringALL(CSca sca, BOOL bDppMsg = TRUE);
	CString SCAStringALLDisplay(CSca sca);
	void InitSCA(CSca *sca, long lChannels=8191, BOOL bTest = FALSE);
};
